////////////////////////////////////////////////////////////////////////////////
//
//  TeraPad jbg Ver.0.18
//
////////////////////////////////////////////////////////////////////////////////

unit TeraPad;

interface

uses
  Windows,
  Messages,
  SysUtils;

const
  MAX_GETTEXT_SIZE    = 65534;          // WM_GETTEXT Ŏ擾őeLXg

  TP_OUTPUT_OFF = 0;
  TP_OUTPUT_ON  = 1;

  TP_TEXT_ALL         = 0;
  TP_TEXT_SEL         = 1;
  TP_TEXT_LINES       = 2;
  TP_MAP_PREFIX       = 'TeraPad_Map_'; // }bsOt@CIuWFNg̖O

  TP_NUM_ROW          = 0;              // `悳PsƂ̍sԍ
  TP_NUM_LINE         = 1;              // ܂Ԃ\ĂPsɑΉsԍ(_s)

  TPMSG_ROWJUMP       = WM_USER + 100;  // sړ
  TPMSG_ROWJUNP       = TPMSG_ROWJUMP;  // sړ(ȑÕXy~Xo[WƂ̌݊ۂ߂Ɂcf(^^;))
  TPMSG_READINI       = WM_USER + 101;  // INIǂݍŔf
  TPMSG_ENDJUNP       = WM_USER + 102;  // ړ
  TPMSG_SAVEFILE      = WM_APP  + 400;  // ㏑ۑs
  TPMSG_LOADFILE      = WM_APP  + 401;  // TeraPadɃt@Cǂݍ܂
  TPMSG_GETACTIVEEDIT = WM_APP  + 402;  // ANeBuȃGfBbgRg[̃nh擾
  TPMSG_SETSBHINTSTR  = WM_APP  + 403;  // Xe[^Xo[̃qgɕZbg
  TPMSG_GETEDITMODE   = WM_APP  + 404;  // ҏW[h擾
  TPMSG_GETSELMODE    = WM_APP  + 405;  // I[h擾(-1:I, 0:I, 1:`I)
  TPMSG_SETINIDIR     = WM_APP  + 406;  // CӂINItH_̐ݒǂݍŔf
  TPMSG_GETTEXT       = WM_APP  + 410;  // Xbvt@CoRŃeLXg擾
  TPMSG_SETTEXT       = WM_APP  + 411;  // Xbvt@CoRŃeLXgݒ肷
  TPMSG_GETNUM        = WM_APP  + 412;  // Lbgʒu̍sԍ擾
  TPMSG_GETROWCOUNT   = WM_APP  + 413;  // ANeBuȃGfBbgRg[̕\s擾
  TPMSG_GETCOLCOUNT   = WM_APP  + 414;  // ANeBuȃGfBbgRg[̕\擾
  TPMSG_GETTOPROW     = WM_APP  + 415;  // ANeBuȃGfBbgRg[̉ʏ[̍sԍ擾
  TPMSG_GETTOPCOL     = WM_APP  + 416;  // ANeBuȃGfBbgRg[̉ʍ[̌ԍ擾
  TPMSG_GETOUTPUTMODE = WM_APP  + 417;  // Output[hH𒲂ׂ
  TPMSG_SETOUTPUTMODE = WM_APP  + 418;  // Output[hZbg(s0, 1Ԃ)
  TPMSG_SETSEL        = WM_APP  + 419;  // EM_SETSELTeraPad(WIndows95/98/MełȂH)

type
  TEditMode = (
               emNone,
               emDef,
               emHtml,
               emPerl,
               emRuby,
               emIni,
               emBat,
               emCpp,
               emJava,
               emVb,
               emHsp,
               emDelphi
               );

var
  // RegisterClipboardFormat('TEditor Box Type'); cf Initialization section
  CF_BOXTEXT: Word;

  // TeraPad̃c[Nꍇ́ATeraPad̃EBhEnhA
  // PƂŋNꍇ NULL i[B
  TeraPadWindow: HWND;
  TpAppWindow: HWND;

{}

// TeraPad̃CEBhEH
function IsTeraPadWindow(Wnd: HWND): Boolean;

// ANeBuȃGfBbgRg[̃nh擾
function TpGetActiveEditWnd(TpWnd: HWND): HWND;

// ҏW[h擾
function TpGetEditMode(TpWnd: HWND): TEditMode;

// TeraPad̃eLXgTCY擾
// TCYzꍇ -1 Ԃ
function TpGetTextSize(TpWnd: HWND): integer;

// eLXgTCY擾
// TCYzꍇ -1 Ԃ
function TpLength(S: string): integer;

// SẴeLXg擾
function TpGetText(TpWnd: HWND): string;

// SẴeLXg擾(Xbvt@CoR)
function TpGetTextEx(TpWnd: HWND): string;

// SẴeLXgZbg
procedure TpSetText(TpWnd: HWND; Text: string);

// SẴeLXgZbg(Xbvt@CoR)
// *ɖ߂^Cv
procedure TpSetTextEx(TpWnd: HWND; Text: string);

// SẴeLXgZbg(Xbvt@CoR)
// *ɖ߂ȂZbg̃XN[X[Y
procedure TpSetTextExLines(TpWnd: HWND; Text: string);

// SẴeLXgI
procedure TpSelectAll(TpWnd: HWND);

// eLXg̊JnʒuIʒu܂őI
procedure TpSelect(TpWnd: HWND; StartIndex, EndIndex: integer);

// IeLXg擾
function TpGetSelText(TpWnd: HWND): string;

// IeLXg擾(Xbvt@CoR)
function TpGetSelTextEx(TpWnd: HWND): string;

// ÏɃeLXgZbg
procedure TpReplaceSel(TpWnd: HWND; Text: string);

// ÏɃeLXgZbg(Xbvt@CoR)
procedure TpReplaceSelEx(TpWnd: HWND; Text: string);

// TeraPad̎st@C̃pX擾
function TpGetPath(TpWnd: HWND): string;

// TeraPad̃o[W擾
function TpGetVer(TpWnd: HWND): string;

// TeraPadɃt@Cǂݍ܂
procedure TpLoadFile(TpWnd: HWND; FilePath: string);

// ㏑ۑs
procedure TpSaveFile(TpWnd: HWND);

// TeraPad̃Xe[^Xo[̃qg̈ɕZbg
procedure TpSetHint(TpWnd: HWND; Text: string);

// Nbv{[h̃eLXg擾
// TeraPadŋ`IŃRs[eLXg̏ꍇ true Ԃ
function TpGetClipboardText(var Text: string): Boolean;

// Nbv{[hփeLXg𑗂
//   Text: Nbv{[h֑eLXg
//   Box : `\tꍇ true Zbg
procedure TpSetClipboardText(Text: string; Box: Boolean);

// Ï̃eLXgNbv{[hփRs[
procedure TpCopy(TpWnd: HWND);

// Ï̃eLXg폜ăNbv{[hփRs[(؂)
procedure TpCut(TpWnd: HWND);

// Nbv{[h̃eLXg\t
procedure TpPaste(TpWnd: HWND);

// sړ
//   Row : ړs
//   Line: _sňړ
procedure TpRowJump(TpWnd: HWND; Row: integer; Line: Boolean);

// ړ
procedure TpEndJump(TpWnd: HWND);

// INIǂݍŔf
procedure TpReadIni(TpWnd: HWND);

// TeraPadANeBuɂ
procedure TpActiveWindow(TpWnd: HWND);

// I[h擾
// ߂l: -1=I, 0=I, 1=`I
function TpGetSelMode(TpWnd: HWND): integer;

// TeraPadINIt@C̃pX擾
function TpGetIniPath(TpWnd: HWND): string;

// CӂINItH_̐ݒǂݍŔf
procedure TpSetIniDir(TpWnd: HWND; IniDir: string);

// Lbgʒu̍sԍ擾
// NumMode: TP_NUM_ROW=`悳PsƂ̍sԍ, TP_NUM_LINE=_s
function TpGetNum(TpWnd: HWND; NumMode: integer): integer;

//ANeBuȃGfBbgRg[̕\s擾
function TpGetRowCount(TpWnd: HWND): integer;

//ANeBuȃGfBbgRg[̕\擾
function TpGetColCount(TpWnd: HWND): integer;

//ANeBuȃGfBbgRg[̉ʏ[̍sԍ擾
function TpGetTopRow(TpWnd: HWND): integer;

//ANeBuȃGfBbgRg[̉ʍ[̌ԍ擾
function TpGetTopCol(TpWnd: HWND): integer;

// c[o[̃EBhEnh擾
function TpGetToolbarWnd(TpWnd: HWND): HWND;

// TeraPadŕҏW̃t@CpX擾
function TpGetFilePath(TpWnd: HWND): string;

// TeraPadOutput[hH𒲂ׂ
// Output[hTrueԂ
function TpGetOutputMode(TpWnd: HWND): Boolean;

// Output[hZbg
// trueԂ
// OutputMode=true  :u and XVvȊO͎s
// OutputMode=false : Output[hȊO͎s
function TpSetOutputMode(TpWnd: HWND; OutputMode: Boolean): Boolean;

// EM_SETSELTeraPad
// EM_SETSELƈႢTpWndTeraPad̃CtH[̃EBhEnhw
procedure TpSetSel(TpWnd: HWND; nStart, nEnd: integer);

{}

implementation

// OS̎ނ𒲂ׂ
// ߂l
//   Win3.1
//   Win95
//   Win98
//   WinMe
//   WinNT
function GetOs: string;
var
  OSVersionInfo : TOSVersionInfo;
  Platform: string;
begin
  Result := '';
  Platform := '';
  OsVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  GetVersionEx(OsVersionInfo);

  with OSVersionInfo do
  begin
    case OsVersionInfo.dwPlatformId of
      VER_PLATFORM_WIN32s       : Platform :='Win3.1';
      VER_PLATFORM_WIN32_WINDOWS:
      begin
        case Win32MinorVersion of
          0: Platform :='Win95';
          10: Platform :='Win98';
          90: Platform :='WinMe';
        end;
      end;
      VER_PLATFORM_WIN32_NT: Platform :='WinNT';
    end;
  end;

  Result := Platform;
end;

////////////////////////////////////////////////////////////////////////////////

// TeraPad̃CEBhEH
function IsTeraPadWindow(Wnd: HWND): Boolean;
var
  Cls: array[0..255] of Char;
begin
  Result := false;
  if Wnd = HWND(nil) then Exit;

  GetClassName(Wnd, Cls, 255);
  if Cls = 'TTeraPadMainForm' then
    Result := true;
end;

// ANeBuȃGfBbgRg[̃nh擾
function TpGetActiveEditWnd(TpWnd: HWND): HWND;
begin
  Result := HWND(nil);
  if IsTeraPadWindow(TpWnd) then
    Result := SendMessage(TpWnd, TPMSG_GETACTIVEEDIT, 0, 0);
end;

// ҏW[h擾
function TpGetEditMode(TpWnd: HWND): TEditMode;
var
  ModeInt: integer;
begin
  Result := emNone;

  if IsTeraPadWindow(TpWnd) then
  begin
    ModeInt := SendMessage(TpWnd, TPMSG_GETEDITMODE, 0, 0);

    case ModeInt of
       1: Result := emHtml;
       2: Result := emPerl;
       3: Result := emIni;
       4: Result := emBat;
       5: Result := emCpp;
       6: Result := emJava;
       7: Result := emVb;
       8: Result := emHsp;
       9: Result := emDelphi;
      10: Result := emRuby;
    else
         Result := emDef;
    end;
  end;
end;

// TeraPad̃eLXgTCY擾
// TCYzꍇ -1 Ԃ
function TpGetTextSize(TpWnd: HWND): integer;
var
  TpEdWnd: HWND;
begin
  Result := -1;

  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    Result := SendMessage(TpEdWnd, WM_GETTEXTLENGTH, 0, 0);

    // OSuWinNTv̎͐Ȃc
    if GetOs <> 'WinNT' then
    begin
      // WM_GETTEXT Ŏ擾łTCYI[o[Ăꍇ -1 Ԃ
      if Result > MAX_GETTEXT_SIZE then
        Result := -1;
    end;
  end;
end;

// eLXgTCY擾
// TCYzꍇ -1 Ԃ
function TpLength(S: string): integer;
begin
  if (GetOs <> 'WinNT') and
     (Length(S) > MAX_GETTEXT_SIZE) then
    Result := -1
  else
    Result := Length(S);
end;

// SẴeLXg擾
function TpGetText(TpWnd: HWND): string;
var
  TpEdWnd: HWND;
  Size: Longint;
  Text: string;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    Size := TpGetTextSize(TpWnd);

    // TCYI[o[ GetTextSize = -1 ̎ '' Ԃ
    if Size >= 0 then
    begin
      SetLength(Text, Size);
      SendMessage(TpEdWnd, WM_GETTEXT, Size + 1, Longint(PChar(Text)));
      Result := Text;
    end;
  end;
end;

// SẴeLXgZbg
procedure TpSetText(TpWnd: HWND; Text: string);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    // OSuWinNTv̎͐Ȃc
    if GetOs <> 'WinNT' then
      // I[o[Ăꍇ͐؂̂
      Text := Copy(Text, 1, MAX_GETTEXT_SIZE);

    SendMessage(TpEdWnd, WM_SETTEXT, 0, Longint(PChar(Text)));
  end;
end;

// SẴeLXgI
procedure TpSelectAll(TpWnd: HWND);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    SendMessage(TpEdWnd, EM_SETSEL, 0, -1);
  end;
end;

// eLXg̊JnʒuIʒu܂őI
procedure TpSelect(TpWnd: HWND; StartIndex, EndIndex: integer);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    SendMessage(TpEdWnd, EM_SETSEL, StartIndex, EndIndex);
  end;
end;

// IeLXg擾
function TpGetSelText(TpWnd: HWND): string;
var
  TpEdWnd: HWND;
  Size: Longint;
  Text: string;
  SelText: string;
  //Sel: DWORD;
  SelStart, SelEnd: DWORD;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    Size := TpGetTextSize(TpWnd);

    // TCYI[o[ GetTextSize = -1 ̎ '' Ԃ
    if Size >= 0 then
    begin
      SetLength(Text, Size);
      SendMessage(TpEdWnd, WM_GETTEXT, Size + 1, Longint(PChar(Text)));

      //Sel := SendMessage(TpEdWnd, EM_GETSEL, 0, 0);
      //SelText := Copy(Text, LoWord(Sel) + 1, HiWord(Sel) - LoWord(Sel));

      SendMessage(TpEdWnd, EM_GETSEL, lParam(@SelStart), wParam(@SelEnd));
      SelText := Copy(Text, SelStart + 1, SelEnd - SelStart);

      Result := SelText;
    end;
  end;
end;

// ÏɃeLXgZbg
procedure TpReplaceSel(TpWnd: HWND; Text: string);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    // OSuWinNTv̎͐Ȃc
    if GetOs <> 'WinNT' then
      // I[o[Ăꍇ͐؂̂
      Text := Copy(Text, 1, MAX_GETTEXT_SIZE);

    SendMessage(TpEdWnd, EM_REPLACESEL, 0, Longint(PChar(Text)));
  end;
end;

// TeraPad̎st@C̃pX擾
function TpGetPath(TpWnd: HWND): string;
var
  PathEditWnd: HWND;
  Buf: PChar;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    Buf := StrAlloc(256);
    try
      PathEditWnd := FindWindowEx(TpWnd, 0, 'TTeraPadExeName', nil);

      if PathEditWnd <> HWND(nil) then
      begin
        SendMessage(PathEditWnd, WM_GETTEXT, 256, longint(Buf));
        Result := string(Buf);
      end;
    finally
      StrDispose(Buf);
    end;
  end;
end;

// TeraPad̃o[W擾
function TpGetVer(TpWnd: HWND): string;
var
  sTMP, sLocale, TpPath: string;
  BufSize: integer;
  pBuf, pInfo: Pointer;
  InfoLen: UINT;
  D: DWORD;
begin
  Result := 'None';

  if IsTeraPadWindow(TpWnd) then
  begin
    TpPath := TpGetPath(TpWnd);

    BufSize := GetFileVersionInfoSize(PChar(TpPath), D);
    GetMem(pBuf, BufSize);
    try
      GetFileVersionInfo(PChar(TpPath), 0, BufSize, pBuf);
      VerQueryValue(pBuf, PChar('\VarFileInfo\Translation'),pInfo, InfoLen);

      if InfoLen > 0 then
        sLocale := IntToHex(Integer(pInfo^), 8)
      else
        Exit;

      sLocale := Copy(sLocale, 5, 4) + Copy(sLocale, 1, 4);

      sTMP := '\StringFileInfo\' + sLocale + '\ProductVersion';
      VerQueryValue(pBuf, PChar(sTMP), pInfo, InfoLen);

      if InfoLen > 0 then
        Result := PChar(pInfo);
    finally
      FreeMem(pBuf);
    end;
  end;
end;

// TeraPadɃt@Cǂݍ܂
procedure TpLoadFile(TpWnd: HWND; FilePath: string);
var
  TpEdWnd: HWND;
  Modify: Longint;
  Atom: TAtom;
begin
  if IsTeraPadWindow(TpWnd) and (FilePath <> '') then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    Modify := SendMessage(TpEdWnd, EM_GETMODIFY, 0, 0);

    // Bool(Modify) = true ɎsƊmFbZ[W\
    // Bool(Modify) = true ɏ㏑ۑꍇ̓Tv\[X TpSave ̕@Łc

    //ύXĂȂꍇ̂݃t@Cǂݍ
    if not Bool(Modify) then
    begin
      Atom := GlobalAddAtom(@FilePath[1]); // GlobalAtomɏ

      if Atom <> 0 then
        SendMessage(TpWnd, TPMSG_LOADFILE, 0, Atom);
    end;
  end;
end;

// ㏑ۑs
procedure TpSaveFile(TpWnd: HWND);
var
  TpEdWnd: HWND;
  Modify: Longint;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    Modify := SendMessage(TpEdWnd, EM_GETMODIFY, 0, 0);

    //ύXĂꍇ̂ݏ㏑ۑ
    if Bool(Modify) then
      SendMessage(TpWnd, TPMSG_SAVEFILE, 0, 0);
  end;
end;

// TeraPad̃Xe[^Xo[̃qg̈ɕZbg
procedure TpSetHint(TpWnd: HWND; Text: string);
var
  Atom: TAtom;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    Atom := GlobalAddAtom(@Text[1]); // GlobalAtomɏ

    if Atom <> 0 then
      SendMessage(TpWnd, TPMSG_SETSBHINTSTR, 0, Atom);
  end;
end;

// Nbv{[h̃eLXg擾
// TeraPadŋ`IŃRs[eLXg̏ꍇ true Ԃ
function TpGetClipboardText(var Text: string): Boolean;
var
  DataStr: THandle;
  DataBox: THandle;
begin
  Result := false;

  {Nbv{[h̏ꍇ͑҂BBB}
  while (GetOpenClipboardWindow <> HWND(nil)) do;

  OpenClipboard(HWND(nil));
  DataStr := GetClipboardData(CF_TEXT);
  DataBox := GetClipboardData(CF_BOXTEXT);
  try
    if DataStr <> 0 then
    begin
      Text := PChar(GlobalLock(DataStr));

      //`IeLXgH
      if DataBox <> 0 then
        Result := true;
    end
    else
      Text := '';
  finally
    if DataStr <> 0 then GlobalUnlock(DataStr);
    CloseClipboard;
  end;
end;

// Nbv{[hփeLXg𑗂
//   Text: Nbv{[h֑eLXg
//   Box : `\tꍇ true Zbg
procedure TpSetClipboardText(Text: string; Box: Boolean);
var
  Data: THandle;
  Size:integer;
  Mem: Pointer;
begin
  {Nbv{[h̏ꍇ͑҂BBB}
  while (GetOpenClipboardWindow <> HWND(nil)) do;

  Size := Length(Text) + 1;
  try
    Data := GlobalAlloc(GMEM_MOVEABLE, Size);
    OpenClipboard(HWND(nil));
    EmptyClipboard;
    try
      Mem := GlobalLock(Data);
      try
        CopyMemory(Mem, pChar(Text), Size);
        SetClipboardData(CF_TEXT, Data);
        
        if Box then
          SetClipboardData(CF_BOXTEXT, Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
    end;
  finally
    CloseClipboard;
  end;
end;

// Ï̃eLXgNbv{[hփRs[
procedure TpCopy(TpWnd: HWND);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    SendMessage(TpEdWnd, WM_COPY, 0, 0);
  end;
end;

// Ï̃eLXg폜ăNbv{[hփRs[(؂)
procedure TpCut(TpWnd: HWND);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    SendMessage(TpEdWnd, WM_CUT, 0, 0);
  end;
end;

// Nbv{[h̃eLXg\t
procedure TpPaste(TpWnd: HWND);
var
  TpEdWnd: HWND;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    SendMessage(TpEdWnd, WM_PASTE, 0, 0);
  end;
end;

// sړ
//   Row : ړs
//   Line: _sňړ
procedure TpRowJump(TpWnd: HWND; Row: integer; Line: Boolean);
var
  L: integer;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    if Line then
      L := 1
    else
      L := 0;

    SendMessage(TpWnd, TPMSG_ROWJUMP, Row, L);
  end;
end;

// ړ
procedure TpEndJump(TpWnd: HWND);
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    SendMessage(TpWnd, TPMSG_ENDJUNP, 1, 0);
  end;
end;

// INIǂݍŔf
procedure TpReadIni(TpWnd: HWND);
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    SendMessage(TpWnd, TPMSG_READINI, 0, 0);
  end;
end;

// TeraPadANeBuɂ
procedure TpActiveWindow(TpWnd: HWND);
var
  dwTpTID,
  dwActiveTID: DWORD;
  sp_time: Longint;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    dwActiveTID := GetWindowThreadProcessId(GetForegroundWindow, nil);
    dwTpTID     := GetWindowThreadProcessId(TpWnd, nil);
  
    AttachThreadInput(dwTpTID, dwActiveTID, true);
  
    SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @sp_time, 0);
    SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, Pointer(0), 0);
    try
      SetForegroundWindow(TpWnd);
    finally
      SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, @sp_time, 0);
      AttachThreadInput(dwTpTID, dwActiveTID, false);
    end;
  end;
end;

// I[h擾
// ߂l: -1=I, 0=I, 1=`I
function TpGetSelMode(TpWnd: HWND): integer;
begin
  Result := 0;

  if IsTeraPadWindow(TpWnd) then
  begin
    Result := SendMessage(TpWnd, TPMSG_GETSELMODE, 0, 0);
  end;
end;

// TeraPadINIt@C̃pX擾
function TpGetIniPath(TpWnd: HWND): string;
var
  PathEditWnd: HWND;
  Buf: PChar;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    Buf := StrAlloc(256);
    try
      PathEditWnd := FindWindowEx(TpWnd, 0, 'TTeraPadIniFilePath', nil);

      if PathEditWnd <> HWND(nil) then
      begin
        SendMessage(PathEditWnd, WM_GETTEXT, 256, longint(Buf));
        Result := string(Buf);
      end;
    finally
      StrDispose(Buf);
    end;
  end;
end;

// CӂINItH_̐ݒǂݍŔf
procedure TpSetIniDir(TpWnd: HWND; IniDir: string);
var
  Atom: TAtom;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    Atom := GlobalAddAtom(@IniDir[1]); // GlobalAtomɏ

    if Atom <> 0 then
      SendMessage(TpWnd, TPMSG_SETINIDIR, 0, Atom);
  end;
end;

// Lbgʒu̍sԍ擾
function TpGetNum(TpWnd: HWND; NumMode: integer): integer;
begin
  Result := SendMessage(TpWnd, TPMSG_GETNUM, NumMode, 0);
end;

//ANeBuȃGfBbgRg[̕\s擾
function TpGetRowCount(TpWnd: HWND): integer;
begin
  Result := SendMessage(TpWnd, TPMSG_GETROWCOUNT, 0, 0);
end;

//ANeBuȃGfBbgRg[̕\擾
function TpGetColCount(TpWnd: HWND): integer;
begin
  Result := SendMessage(TpWnd, TPMSG_GETCOLCOUNT, 0, 0);
end;

//ANeBuȃGfBbgRg[̉ʏ[̍sԍ擾
function TpGetTopRow(TpWnd: HWND): integer;
begin
  Result := SendMessage(TpWnd, TPMSG_GETTOPROW, 0, 0);
end;

//ANeBuȃGfBbgRg[̉ʍ[̌ԍ擾
function TpGetTopCol(TpWnd: HWND): integer;
begin
  Result := SendMessage(TpWnd, TPMSG_GETTOPCOL, 0, 0);
end;

// c[o[̃EBhEnh擾
function TpGetToolbarWnd(TpWnd: HWND): HWND;
begin
  Result := FindWindowEx(TpWnd, 0, 'TToolbar', nil);
end;

// TeraPadŕҏW̃t@CpX擾
function TpGetFilePath(TpWnd: HWND): string;
var
  PathEditWnd: HWND;
  Buf: PChar;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    Buf := StrAlloc(256);
    try
      PathEditWnd := FindWindowEx(TpWnd, 0, 'TEdit', nil);

      if PathEditWnd <> HWND(nil) then
      begin
        SendMessage(PathEditWnd, WM_GETTEXT, 256, longint(Buf));
        Result := string(Buf);
      end;
    finally
      StrDispose(Buf);
    end;
  end;
end;

// TeraPadOutput[hH𒲂ׂ
// Output[hTrueԂ
function TpGetOutputMode(TpWnd: HWND): Boolean;
begin
  Result := Boolean(SendMessage(TpWnd, TPMSG_GETOUTPUTMODE, 0, 0));
end;

// Output[hZbg
// trueԂ
// OutputMode=true  :u and XVvȊO͎s
// OutputMode=false : Output[hȊO͎s
function TpSetOutputMode(TpWnd: HWND; OutputMode: Boolean): Boolean;
begin
  if OutputMode then
    Result := Boolean(SendMessage(TpWnd, TPMSG_SETOUTPUTMODE, TP_OUTPUT_ON, 0))
  else
    Result := Boolean(SendMessage(TpWnd, TPMSG_SETOUTPUTMODE, TP_OUTPUT_OFF, 0));
end;

// EM_SETSELTeraPad
// EM_SETSELƈႢTpWndTeraPad̃CtH[̃EBhEnhw
procedure TpSetSel(TpWnd: HWND; nStart, nEnd: integer);
begin
  SendMessage(TpWnd, TPMSG_SETSEL, nStart, nEnd);
end;

////////////////////////////////////////////////////////////////////////////////

function GetTextEx(TpWnd: HWND; AllSel: integer): string;
var
  TpEdWnd: HWND;
  dwSize: integer;
  Buf: string;
  MemoryPos: Pointer;
  hMap: THandle;
  S: PChar;
begin
  Result := '';

  if IsTeraPadWindow(TpWnd) then
  begin
    // 擾eLXg̃TCY𒲂ׂ
    TpEdWnd := TpGetActiveEditWnd(TpWnd);
    dwSize := SendMessage(TpEdWnd, WM_GETTEXTLENGTH, 0, 0) + 1;
    // }bvIuWFNg쐬
    Buf := Format('%s%u', [TP_MAP_PREFIX, TpWnd]);
    hMap := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, dwSize, PChar(Buf));
    if hMap <> 0 then
    begin
      // }bvIuWFNg݉\ȃ̈ɌŒ肷
      MemoryPos := MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0);
      if MemoryPos <> nil then
      begin
        // ̈
        ZeroMemory(MemoryPos, dwSize);
        // }bvIuWFNg̈悩
        UnmapViewOfFile(MemoryPos);
        // eLXg擾
        if Boolean(SendMessage(TpWnd, TPMSG_GETTEXT, AllSel, 0)) then
        begin
          // }bvIuWFNgǂݎ\ȃ̈ɌŒ肷
          MemoryPos := MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0);
          if MemoryPos <> nil then
          begin
            // }bsOt@Cf[^Rs[
            S := StrAlloc(dwSize);
            try
              CopyMemory(S, MemoryPos, dwSize);
              // eLXg̐ݒ
              Result := string(S);
              // }bvIuWFNg̈悩
              UnmapViewOfFile(MemoryPos);
            finally
              StrDispose(S);
            end;
          end;
        end;
      end;
      // }bvIuWFNg
      CloseHandle(hMap);
    end;
  end;
end;

// SẴeLXg擾(Xbvt@CoR)
function TpGetTextEx(TpWnd: HWND): string;
begin
  Result := GetTextEx(TpWnd, TP_TEXT_ALL);
end;

// IeLXg擾(Xbvt@CoR)
function TpGetSelTextEx(TpWnd: HWND): string;
begin
  Result := GetTextEx(TpWnd, TP_TEXT_SEL);
end;

procedure SetTextEx(TpWnd: HWND; Text: string; AllSel: integer);
var
  dwSize: integer;
  Buf: string;
  MemoryPos: Pointer;
  hMap: THandle;
  S: PChar;
begin
  if IsTeraPadWindow(TpWnd) then
  begin
    // ݒ肷eLXg̃TCY𒲂ׂ
    dwSize := Length(Text) + 1;
    // }bvIuWFNg쐬
    Buf := Format('%s%u', [TP_MAP_PREFIX, TpWnd]);
    hMap := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, dwSize, PChar(Buf));
    if hMap <> 0 then
    begin
      // }bvIuWFNg݉\ȃ̈ɌŒ肷
      MemoryPos := MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0);
      if MemoryPos <> nil then
      begin
        // ̈ɃeLXgRs[
        S := StrAlloc(dwSize);
        S := StrCopy(S, PChar(Text));
        try
          CopyMemory(MemoryPos, S, dwSize);
        finally
          StrDispose(S);
        end;
        // }bvIuWFNg̈悩
        UnmapViewOfFile(MemoryPos);
        // eLXgݒ
        SendMessage(TpWnd, TPMSG_SETTEXT, AllSel, dwSize);
      end;
      // }bvIuWFNg
      CloseHandle(hMap);
    end;
  end;
end;

// SẴeLXgZbg(Xbvt@CoR)
// *ɖ߂^Cv
procedure TpSetTextEx(TpWnd: HWND; Text: string);
begin
  SetTextEx(TpWnd, Text, TP_TEXT_ALL);
end;

// SẴeLXgZbg(Xbvt@CoR)
// *ɖ߂ȂZbg̃XN[X[Y
procedure TpSetTextExLines(TpWnd: HWND; Text: string);
begin
  SetTextEx(TpWnd, Text, TP_TEXT_LINES);
end;

// ÏɃeLXgZbg(Xbvt@CoR)
procedure TpReplaceSelEx(TpWnd: HWND; Text: string);
begin
  SetTextEx(TpWnd, Text, TP_TEXT_SEL);
end;

////////////////////////////////////////////////////////////////////////////////

initialization
  CF_BOXTEXT := RegisterClipboardFormat('TEditor Box Type');

  TpAppWindow := HWND(nil);
  TeraPadWindow := GetForegroundWindow;
  if Not IsTeraPadWindow(TeraPadWindow) then
    TeraPadWindow := HWND(nil)
  else
    TpAppWindow := GetWindow(TeraPadWindow, GW_OWNER);

end.
